#include "InteractGeoStreamFile.h"
#include <float.h>



namespace Interact {
namespace GeoStream {




File::File(const std::string &filename)
	: main_file(filename),
	index_file(filename+".index")
	{
	low.x=FLT_MAX;
	low.y=FLT_MAX;
	low.z=FLT_MAX;

	high.x=FLT_MIN;
	high.y=FLT_MIN;
	high.z=FLT_MIN;
	}



File::~File()
	{
	BinaryFile::Offset toc=index_file.Position();
	
	index_file.Output(channel_name.size());

	index_file.Output(low);
	index_file.Output(high);
	
	for(int i=0;i<channel_name.size();++i)
		{
		index_file.Output(channel_name[i].size());
		index_file.Output(channel_name[i].c_str(),channel_name[i].size());
			///#### is this valid?
		index_file.Output(int(channel_triple[i]));
		
		//fprintf(stderr,"%s\n",channel_triple[i]?"triple":"single");
		}
		
	index_file.Output(toc);
	
	int version=0;
	
	index_file.Output(version);
	}




//### static_cast

void File::OutputGrid(ChannelSet &set,int width,int height,int offset)
	{
	Channel *c=set.FindChannel("P",true);
	
	if(c->data.size()==0)
		{
		fprintf(stderr,"no P\n");
		exit(1);
		}
	
	
	// Calculate the centroid of the grid
		
	Coord *p=((Coord *)&*c->data.begin())+offset;
	
	
	Coord centroid;
	
	centroid.x=(p[0].x+p[width-1].x+p[width*(height-1)].x+p[width*(height-1)+width-1].x)/4;
	centroid.y=(p[0].y+p[width-1].y+p[width*(height-1)].y+p[width*(height-1)+width-1].y)/4;
	centroid.z=(p[0].z+p[width-1].z+p[width*(height-1)].z+p[width*(height-1)+width-1].z)/4;
	
	index_file.Output(main_file.Position());
	index_file.Output(centroid);
	
	
	if(centroid.x<low.x)
		low.x=centroid.x;
	if(centroid.y<low.y)
		low.y=centroid.y;
	if(centroid.z<low.z)
		low.z=centroid.z;
	
	if(centroid.x>high.x)
		high.x=centroid.x;
	if(centroid.y>high.y)
		high.y=centroid.y;
	if(centroid.z>high.z)
		high.z=centroid.z;
	
	
	
	int n=set.size();
	
	main_file.Output(width);
	main_file.Output(height);
	
	main_file.Output(n);
	
	
	for(ChannelSet::iterator i=set.begin();i!=set.end();++i)
		{
		/// Add this channel to the file-wide map.
		//###d and output
		
		std::map<std::string,int>::iterator ni=channel_name_to_index.find(i->first);
			//###d check the triple thing
			
		if(ni!=channel_name_to_index.end())
			main_file.Output(ni->second);
		else
			{
			main_file.Output(channel_name.size());
			
			channel_name_to_index[i->first]=channel_name.size();
			
			channel_name.push_back(i->first);
			channel_triple.push_back(i->second->triple);
			}
			
		
		int size=i->second->triple?3:1;
		
		float *p=&*i->second->data.begin()+offset*size;
		
		main_file.Output(p,width*height*size*sizeof(float));
		}
	}




}
}
