#include "RemoteLens.h"
#include "ShadeopUtils.h"


#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>








RemoteLens::RemoteLens()
	: socket("localhost",7178)
	{
	fprintf(stderr,"### Init\n");

	pos_count=0;
	dir_count=0;
	col_count=0;
	
	ShadeopUtils::Progress("Remote lens constructed");
	
	bufpoi=NULL;
	buffer=NULL;
	
	packet.sx=0;
	packet.sy=0;
		/// Force an immediate packet.cket receive.
		
	for(int i=0;i<N_VARS;++i)
		var[i]=0;



	first_x=true;
	first_y=true;
	dx_valid=false;
	dy_valid=false;
	dx=1;
	dy=1;


	}


RemoteLens::~RemoteLens()
	{
	
	//####kill buffer?

	ShadeopUtils::Progress("Remote lens destructed");
	}


bool RemoteLens::CheckPacket()
	{
	if(col_count>=(packet.sx*packet.sy))
		{
		int r;
		
		// Get next packet.cket
		
		if(buffer!=NULL)
			/// Write out the existing buffer if there is one
			{
			socket.HandleOutputBytes(buffer,packet.sx*packet.sy*4);
			
			free(buffer);
			}
		
		int code;
		
		ShadeopUtils::Progress("Remote lens waiting...");

		do {
			r=socket.HandleInputBytes(&code,sizeof(int));

			if(r<=0)
				ShadeopUtils::Error("Remote lens finished");
			
			if(code==1)
				{
				int index;
				float value;
				
				socket.HandleInputBytes(&index,sizeof(int));
				socket.HandleInputBytes(&value,sizeof(float));
				
//				fprintf(stderr,"value %d %f\n",index,value);

				if(index>0 && index<N_VARS)
					var[index]=value;
				}

			} while(code!=0);
		
//		fprintf(stderr,"packet...\n");
		
		r=socket.HandleInputBytes(&packet,sizeof(struct Packet));
		
		if(r<=0)
			ShadeopUtils::Error("Remote lens finished");
			
		var[0]=PacketSamples();	
			
		//##ASSERT(r==sizeof(Packet));
			//### check	
			
		//fprintf(stderr,"### Read packet.cket %d %d %d\n",packet.sx,packet.sy,r);
		
		pos_count=0;
		dir_count=0;
		col_count=0;
		
		buffer=(unsigned char *)malloc(packet.sx*packet.sy*4);
			//###new?
		
		if(buffer==NULL)
			ShadeopUtils::Error("Remote lens failed to initialise buffer");
		
		bufpoi=buffer;
		
		return(true);
		}
	else
		return(false);
	}


void RemoteLens::GetOrigin(float *result)
	{
////	fprintf(stderr,"origin %d\n",pos_count);
	
	for(int i=0;i<3;++i)
		result[i]=packet.origin[i];
		
	++pos_count;
	}


void RemoteLens::GetDirection(float *result)
	{
//	fprintf(stderr,"direction %d\n",dir_count);

	float xx=dir_count%packet.sx;
	float yy=dir_count/packet.sx;

	const float OFFSET=0;-0.25; //###d was 0.5

	float x=(xx+OFFSET)/packet.sx*(packet.hx-packet.lx)+packet.lx;
	float y=(yy+OFFSET)/packet.sy*(packet.hy-packet.ly)+packet.ly;
	///####  justify this - add fov
	//####d doc the exact meaning of this

	for(int i=0;i<3;++i)
		result[i]=packet.z[i]+packet.x[i]*x+packet.y[i]*y;
		
	++dir_count;
	}


void RemoteLens::PutColour(float *colour)
	{
//	fprintf(stderr,"colour %d\n",col_count);

	for(int i=0;i<3;++i)
		{
		float v=colour[i];

		if(v<0)
			v=0;
		if(v>1)
			v=1;


		*bufpoi++=(unsigned char)(v*255);
		}

	*bufpoi++=255;
		//### RGBA

	++col_count;
	}


float RemoteLens::PacketSamples() const
	{
	return(packet.samples);
	}




