#include "ShadedGrid.h"
#include <stdio.h>

#include <math.h>


namespace Hx {




ShadedGrid::ShadedGrid()
	{
	Reset();
	}


ShadedGrid::~ShadedGrid()
	{
	}


void ShadedGrid::Reset()
	{
	first=true;
	
	origin[0]=0;
	origin[1]=0;
	
	delta_valid[0]=false;
	delta_valid[1]=false;
	
	delta[0]=1;
	delta[1]=1;
	
	maximum[0]=minimum[0]=0;
	maximum[1]=minimum[1]=0;
	}



void ShadedGrid::Add(const float *value)
	{
	if(first)
		{
		first=false;
		
		origin[0]=value[0];
		origin[1]=value[1];
		}
		
	for(int i=0;i<2;++i)
		{
		if(!delta_valid[i] && fabsf(value[i]-origin[i])>0.00001F)
			{
			delta_valid[i]=true;
			delta[i]=value[i]-origin[i];
			}
			
		if((value[i]-origin[i])/delta[i]<minimum[i])
			minimum[i]=(value[i]-origin[i])/delta[i];

		if((value[i]-origin[i])/delta[i]>maximum[i])
			maximum[i]=(value[i]-origin[i])/delta[i];
		}
	}
	
	
bool ShadedGrid::GetIndex(const float *coord,int *result)
	{
	for(int i=0;i<2;++i)
		result[i]=int(floor((coord[i]-origin[i])/delta[i]+0.5F));
	}

	


void ShadedGrid::Debug()
	{
	fprintf(stderr,"origin: %f,%f\n",origin[0],origin[1]);
	fprintf(stderr,"delta: %f,%f\n",delta[0],delta[1]);
	fprintf(stderr,"minimum: %f,%f\n",minimum[0],minimum[1]);
	fprintf(stderr,"maximum: %f,%f\n",maximum[0],maximum[1]);
	}



}
