#include "SharedMemoryArray.h"

#include "ShadeopUtils.h"

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/types.h>
#include <unistd.h>




SharedMemoryArray::SharedMemoryArray()
	{
	id=shmget('HXPR',1024,0777 | IPC_CREAT);
		/// Access the shared memory segment, creating if necessary.
		
	if(id==-1)
		ShadeopUtils::Error("Failed to create shared memory");

	address=(float *)shmat(id,NULL,0);
		/// Attach with read/write permission.

	if((long)address==-1)
		ShadeopUtils::Error("Failed to attach shared memory");

	ShadeopUtils::Progress("Shared memory constructed");
	}


SharedMemoryArray::~SharedMemoryArray()
	{
	if(shmdt((const void *)address)==-1)
		ShadeopUtils::Error("Failed to detach shared memory");
	}

