#ifndef __hx_TcpSocket_h
#define __hx_TcpSocket_h


#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>






class TcpSocket
	// Class to represent a TCP/IP connection socket.
	
	//P Communications
	{
	TcpSocket(const TcpSocket &);
	TcpSocket &operator=(const TcpSocket &);

	int sockfd;
	char ipaddr[32];
	
	struct sockaddr_in serv_addr;
	struct hostent *hostentry;

	TcpSocket(int s);
public:
	//H Public Methods
	//S Construction
	TcpSocket(char *hostname,int port,bool listen_socket=false);
		// If <B>listen_socket</B> is FALSE, construct and connect a socket to (<B>hostname</B>,<B>port</B>).
		// If <B>listen_socket</B> is TRUE, construct a listening socket on (<B>hostname</B>,<B>port</B>).
		// If <B>hostname</B> is NULL, listen on (all networks,<B>port</B>).
	TcpSocket(char *hostname,char *port,bool listen_socket=false);
		// As above except that <B>port</B> is a text representation looked up in /etc/services. 
	~TcpSocket();
	
	//S Use
	TcpSocket *Accept();
		// Create a new socket for an accepted incoming connection.  If the socket is non-blocking, this can return NULL if no connections are pending.
	
	void SelectNonBlockingInput();
	void SelectBlockingInput();
public:
	int HandleInputBytes(void *buffer,int n);
	void HandleOutputBytes(const void *buffer,int n);
	};






#endif
