#include <stdio.h>
#include <stdlib.h>
#include "shadeop.h"
#include <map>
#include <string>
#include <vector>
#include <memory>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <memory>
#include "InteractGeoStreamBinaryFile.h"
#include "InteractGeoStreamChannel.h"
#include "InteractGeoStreamChannelSet.h"
#include "InteractGeoStreamFile.h"
#include "rx.h"


using namespace std;

using namespace Interact::GeoStream;



std::vector<std::pair<int,int> > Grids(float *begin,float *end)
	{
	std::vector<std::pair<int,int> > result;
	
	int stage=0;
	
	float *g=begin;
	
	std::pair<int,int> s;
	
	int base=0;
	
	for(int i=0;i<(end-begin);++i)
		{
		if(stage==0)
			{
			if(g[i]==0)
				{
				s.first=i-base+1;
				
				stage=1;
				}
			}
		else if(stage==1)
			{
			if(((i-base)%s.first)==0 && g[i]==0)
				{
				s.second=(i-base)/s.first+1;
				
				result.push_back(s);
				
				base=base+s.first*s.second;
				i=base-1;
				
				stage=0;
				}
			}
		}
		
	if(base!=(end-begin))
		{
		for(float *i=begin;i!=end;++i)
			fprintf(stderr,"%c",((*i==0)?'.':'X'));
			
		fprintf(stderr,"\n");
		
		//#### errorr
		exit(1);
		}	
		
	return(result);
	}



class State
	{
public:
	State()
		{
		//fprintf(stderr,"Construct\n");
		
		//### verbose option
		
		char *p;

		RxInfoType_t type;
		int count;
		
		int status=RxOption("user:interact_stream_filename",&p,sizeof(char *),&type,&count);
	
		if(status!=0 || type!=RxInfoStringV || count!=1)
			{
			fprintf(stderr,"filename failed\n");
				//###
			exit(0);
			}
		
		fprintf(stderr,"filename: %s\n",p);

		
		file.reset(new File(p));
		}
		
	~State()
		{
		Finish();
		
		//fprintf(stderr,"Destruct\n");
		}


	void Finish()
		{
		if(channel_set.size()>0)
			{
			Channel *c=channel_set.FindChannel("control",false);
				//### fixed?
				
			// warn if empty
			
			std::vector<std::pair<int,int> > r=Grids(&*c->data.begin(),&*c->data.end());
			
			//fprintf(stderr,"%d\n",r.size());
			
			int offset=0;
			
			for(int i=0;i<r.size();++i)
				{
				
				//fprintf(stderr,"\t%d x %d\n",r[i].first,r[i].second);
				
				file.get()->OutputGrid(channel_set,r[i].first,r[i].second,offset);
				
				offset+=r[i].first*r[i].second;
				}
			}
			
		channel_set.clear();
		}

	
	ChannelSet channel_set;

	auto_ptr<File> file;
	};







static auto_ptr<State> global_state;


State *GlobalState()
	{
	State *result=global_state.get();
	
	if(result==NULL)
		{
		result=new State();
		
		global_state.reset(result);
		}
		
	return(result);
	}



extern "C" {

SHADEOP_TABLE(hb_interact_stream) =
		{
			{ "float hb_interact_stream_start ()","","" },
			{ "float hb_interact_stream_single (string,float)","","" },
			{ "float hb_interact_stream_triple (string,point)","","" },
			{ "float hb_interact_stream_triple (string,vector)","","" },
			{ "float hb_interact_stream_triple (string,normal)","","" },
			{ "float hb_interact_stream_triple (string,color)","","" },
			{ "" }
		};


SHADEOP(hb_interact_stream_start)
	{
	State *s=GlobalState();
	
//	for(ChannelSet::iterator i=s->channel_set.begin();i!=s->channel_set.end();++i)
//		fprintf(stderr,"%s:%d\n",i->second->name.c_str(),i->second->data.size());
		
	
	s->Finish();
	
	float *result =(float *)argv[0];

//	fprintf(stderr,"start\n");

	*result=drand48();

	return 0;
	}

SHADEOP(hb_interact_stream_single)
	{
	State *s=GlobalState();
	
	float *result =(float *)argv[0];
	STRING_DESC *name=(STRING_DESC *)argv[1];
	float *value=(float *)argv[2];

	Channel *c=s->channel_set.FindChannel(name->s,false);
	
	c->data.push_back(*value);

	*result=drand48();
		///### for the moment

	return 0;
	}

SHADEOP(hb_interact_stream_triple)
	{
	State *s=GlobalState();
	
	float *result =(float *)argv[0];
	STRING_DESC *name=(STRING_DESC *)argv[1];
	float *value=(float *)argv[2];

	Channel *c=s->channel_set.FindChannel(name->s,true);
	
	c->data.push_back(value[0]);
	c->data.push_back(value[1]);
	c->data.push_back(value[2]);

	*result=drand48();
		///### for the moment

	return 0;
	}

}
